#!/bin/bash
########################################################################
# MonthUpAll 1.4.1 by Turranius                                        #
# This is a script that can del your entire userbase if you are not    #
# careful, or I missed any bugs. It shouldnt do that though, but dont  #
# come crying to me if it did :))                                      #
####                                                                ####
# This is the improved MonthUpAll script. Thanks SUbzEro for the idea. #
# If your site has a limit on how much the users have to upload each   #
# month, it is for you!                                                #
# It can, depending on what you set it to do:                          #
# 1: Inform you in a log file of how much users upped and if they      #
#    passed or not.                                                    #
# 2: Put the 6 flag (user deleted) on those who do not pass. Simply    #
#    readd them or purge manually from glftpd (recomended).            #
# 3: Permanently delete users who does not pass (not recomended).      #
# It will check the passwd file to make sure the user has been on the  #
# site for more then one month before delling.                         #
#                                                                      #
####                                                                ####
# Installation:                                                        #
# Put the 2 .sh scripts in glftpd's bin folder (/glftpd/bin).          #
# Make them executable.                                                #
# Configure monthupalldata.sh as you please & set all paths.           #
# They are all described below.                                        #
# Edit monthupall.sh too and set to where you want the logfile.        #
#                                                                      #
# Note that if you're limit is 2000 MB and someone ups 1999 MB, it     #
# will treat them as "not passed". You might want to set it a bit      #
# below to what you constitute as passed anyway.                       #
#                                                                      #
# MAKE SURE YOU SET DEBUG MODE AND TEST ON TRUE BEFORE DOING ANYTHING  #
# ELSE. LEAVE THEM BOTH ON TRUE. Make a backup of all users and the    #
# passwd file. If you set either FLAGDEL or REALDEL on TRUE then make  #
# sure to set TEST to TRUE atleast once.                               #
#                                                                      #
# If you want to just test it and dont care for fancy output, just run #
# monthupalldata.sh from shell. It wont log to file or sort the output.#
#                                                                      #
# Now crontab it. If you only run logging (FLAGDEL and REALDEL set to  #
# FALSE), then you can run it as often as you like.                    #
# If, however, you run FLAGDEL or REALDEL on TRUE, it is VERY          #
# important that it is only run at the last few minutes of the last    #
# day of the month. I suggest running it 2-5 minutes before midnight   #
# at that day, so that the stats does not reset before its finished.   #
####                                                                ####
# Found a bug? Find Turran or Turranius on Efnet and dont just say hi. #
# Use/change this script as you like. If you make it cooler, atleast   #
# give me credits for it :) If you make it break someones site, dont   #
# give me creds, muahah.                                               #
########################################################################
# Version History:                                                     #
# 1.4.1 : Now checks both year and month to decide if the user was     #
#         added this month.                                            #
# 1.4 : Added AFFILSFOLDER to settings. The names of the folders it    #
#       finds in these folders will be added to EXCLUDEDGROUPS, so if  #
#       you add all your predirs here, they are automatically exlcuded #
#       if the foldername is the same as their groupname.              #
# 1.3 : Possiblility to exclude users that have leech.                 #
#       Wont check for Group exclude on a user if they are User        #
#       excluded anymore. Not much point :)                            #
#       Check that the user has been on the site for more then one     #
#       month before checking how much the user upped. Sounds better,  #
#       dont you think?                                                #
# 1.2b: Now handles up to 9 stat sections. It will simply add them up  #
#       if it finds them. Debug will let you know how many it finds.   #
#       Also does the check for excluded group before checking how     #
#       much the user uploaded. Should be a millisecond faster.        #
# 1.1b: Major rewrite. Can del users etc etc. debug, test, excludes.   #
# 1.0 : Inital release. Just logs.                                     #
########################################################################
# Settings:

USERPATH=/glftpd/ftp-data/users    # Path to userfiles.
PASSWD=/glftpd/etc/passwd          # Path to PASSWD file so we can check what month they were added.
USERFILETMP=/glftpd/tmp/muatmp     # Temp FILE to store stuff. I'll say again, FILE.
BACKUPFOLDER=/glftpd/ftp-data/back # Folder to backup userfiles if BACKUP=TRUE 
LIMIT=2000                         # Limit in MB to upload per month to pass.
EXCLUDEDUSERS="turranius seiko"    # Users to exclude totally from list. Space delimited.
EXCLUDEDGROUPS="Friends SiTEOPS"   # Groups to exclude. Space delimited.
AFFILSFOLDER="/glftpd/site/GROUPS" # Where to look for predirs? Space seperated.
                                   # The dirs found will be added to EXCLUDEGROUPS.
EXCLUDELEECH="TRUE"                # Exclude users that have leech (Ratio 0) ?
FLAGDEL="FALSE"                    # Shall we put flag 6 on those who does not pass?
REALDEL="FALSE"                    # This will delete the userfile and the passwd entry (Dangerous).
DEBUG="TRUE"                       # See/log everything it does (Yes this is good).
TEST="TRUE"                        # Will not put 6 flag or del users but will say it does.

BACKUP="FALSE"                     # Will backup userfiles before doing anything on them
                                   # Only effective if FLAGDEL or REALDEL is TRUE.
                                   # Will also leave a copy of the passwd file in the backup folder
                                   # if REALDEL is TRUE.

####################################################################
# Nothing should be changed below here                             #
####################################################################

## Make some checks to make sure paths are correct, etc.
if [ -e "$PASSWD" ]; then
  if [ "$DEBUG" = "TRUE" ]; then
    echo "DEBUG: Found $PASSWD file OK."
  fi
else
  echo "Cant read $PASSWD file. Check your settings."
  exit 0
fi

if [ -e "$USERPATH" ]; then
  if [ "$DEBUG" = "TRUE" ]; then
    echo "DEBUG: Found $USERPATH folder OK."
  fi  
else
  echo "Cant seem to find the $USERPATH folder. Check your settings."
  exit 0
fi

if [ "$BACKUP" = "TRUE" ]; then
  if [ -e "$BACKUPFOLDER" ]; then
    if [ "$DEBUG" = "TRUE" ]; then
      echo "DEBUG: Found $BACKUPFOLDER folder OK."
    fi  
  else
    echo "Cant seem to find the $BACKUPFOLDER folder. Check your settings."
    exit 0
  fi
fi

touch $USERFILETMP
if [ -e "$USERFILETMP" ]; then
  if [ "$DEBUG" = "TRUE" ]; then
    echo "DEBUG: Found $USERFILETMP file OK."
  fi
else
  echo "Cant read $USERFILETMP file. Check your settings."
  exit 0
fi

## Backup PASSWD file if REALDEL is TRUE.
if [ "$REALDEL" = "TRUE" ]; then
  if [ "$BACKUP" = "TRUE" ]; then
    cp -f $PASSWD $BACKUPFOLDER
  fi
fi 

## Make a new group exclude
if [ "$AFFILSFOLDER" != "" ]; then
  for folder in `echo $AFFILSFOLDER`; do
    if [ -e $folder ]; then
      cd $folder
      for affils in `ls`; do
        GAFFILS="$affils $GAFFILS"
      done
    else
      echo "Can not find $folder specified in AFFILSFOLDER."
      exit 1
    fi
  done
  if [ "$EXCLUDEDGROUPS" = "" ]; then
    EXCLUDEDGROUPS="$GAFFILS"
  else
    EXCLUDEDGROUPS="$EXCLUDEDGROUPS $GAFFILS"
  fi
fi

if [ "$DEBUG" = "TRUE" ]; then
  echo "DEBUG: Following groups are excluded: $EXCLUDEDGROUPS"
fi

cd $USERPATH

MONTH="$(date +%m)"
YEAR="$(date +%y)"
MONTHNOW="$MONTH-$YEAR"
YESYES=""

## For each userfile, do this. Phew, poor computer.
for i in `ls -f -A | egrep -v 'default.user|glftpd|backup|disabled'`
do
  EXCLUDED="$( echo $EXCLUDEDUSERS | grep -w $i )"
  if [ "$EXCLUDED" = "" ]; then
    EX="NO"
  else
    EX="YES"
    if [ "$DEBUG" = "TRUE" ]; then
      echo "DEBUG: User Exclude Match for $i"
    fi
  fi

  if [ "$EX" != "YES" ]; then
    GROUP="$(cat $i | grep -w GROUP | awk '{printf $2 " "}')"
    for eachgroup in $GROUP; do
      if [ "$MATCH" != "YEPP" ]; then
        EXCLUDEDG2="$( echo $EXCLUDEDGROUPS | grep -w $eachgroup )"
        if [ "$EXCLUDEDG2" != "" ]; then
          MATCH="YEPP"
          EX="YES"
          if [ "$DEBUG" = "TRUE" ]; then
            echo "DEBUG: Group Exclude Match for $eachgroup on user $i"
          fi
        fi
      fi
    done
  fi

  if [ "$EX" != "YES" ]; then
    if [ "$EXCLUDELEECH" = "TRUE" ]; then
      if [ "$DEBUG" = "TRUE" ]; then
        if [ "$EXCLUDESAID" != "YEPP" ]; then
          echo "DEBUG: Excluding users with leech."
          EXCLUDESAID="YEPP"
        fi
      fi
      RATIO="$(cat $i | grep -w RATIO | awk -F" " '{print $2}')"
      if [ "$RATIO" = "0" ]; then
        EX="YES"
        if [ "$DEBUG" = "TRUE" ]; then
          echo "DEBUG: Leech Exclude Match for $i"
        fi
      fi
    fi
  fi

  if [ "$EX" != "YES" ]; then
    ## Check if the user has been on site for more then one month.
    MONTHADDED="$(cat $PASSWD | grep -w $i | awk -F":" '{print $5}' | awk -F"-" '{print $1"-"$3}')"
    if [ "$MONTHADDED" = "$MONTHNOW" ]; then
      EX="YES"
      if [ "$DEBUG" = "TRUE" ]; then
        echo "DEBUG: Auto Excluding $i. User added this month."
      fi
    fi
  fi

  if [ "$EX" != "YES" ]; then
    GROUP="$(cat $i | grep GROUP | awk '{printf $2 " "}')"
    for eachgroup in $GROUP; do
      if [ "$MATCH" != "YEPP" ]; then
        EXCLUDEDG2="$( echo $EXCLUDEDGROUPS | grep -w $eachgroup )"
        if [ "$EXCLUDEDG2" != "" ]; then
          MATCH="YEPP"
          EX="YES"
          if [ "$DEBUG" = "TRUE" ]; then
            echo "DEBUG: Group Exclude Match for $eachgroup on user $i"
          fi
        fi
      fi
    done

    if [ "$EX" != "YES" ]; then
      MONTH="$(cat $i | grep MONTHUP | awk -F" " '{print $3}')"

      ## Check for other stats sections.
      MONTH2="$(cat $i | grep MONTHUP | awk -F" " '{print $6}')"
      if [ "$MONTH2" != "" ]; then
        MONTH3="$(cat $i | grep MONTHUP | awk -F" " '{print $9}')"
        if [ "$MONTH3" != "" ]; then
          MONTH4="$(cat $i | grep MONTHUP | awk -F" " '{print $12}')"
          if [ "$MONTH4" != "" ]; then
            MONTH5="$(cat $i | grep MONTHUP | awk -F" " '{print $15}')"
            if [ "$MONTH5" != "" ]; then
              MONTH6="$(cat $i | grep MONTHUP | awk -F" " '{print $18}')"
              if [ "$MONTH6" != "" ]; then
                MONTH7="$(cat $i | grep MONTHUP | awk -F" " '{print $21}')"
                if [ "$MONTH7" != "" ]; then
                  MONTH8="$(cat $i | grep MONTHUP | awk -F" " '{print $24}')"
                  if [ "$MONTH8" != "" ]; then
                    MONTH9="$(cat $i | grep MONTHUP | awk -F" " '{print $27}')"
                    if [ "$MONTH9" != "" ]; then
                      if [ "$DEBUG" = "TRUE" ]; then
                        echo "DEBUG: Nine stat sections found for $i"
                      fi
                      MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" \+ "$MONTH4" \+ "$MONTH5" \+ "$MONTH6" \+ "$MONTH7" \+ "$MONTH8" \+ "$MONTH9" )"
                    else
                      if [ "$DEBUG" = "TRUE" ]; then
                        echo "DEBUG: Eight stat sections found for $i"
                      fi
                      MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" \+ "$MONTH4" \+ "$MONTH5" \+ "$MONTH6" \+ "$MONTH7" \+ "$MONTH8" )"
                    fi
                  else
                    if [ "$DEBUG" = "TRUE" ]; then
                      echo "DEBUG: Seven stat sections found for $i"
                    fi
                    MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" \+ "$MONTH4" \+ "$MONTH5" \+ "$MONTH6" \+ "$MONTH7" )"
                  fi
                else
                  if [ "$DEBUG" = "TRUE" ]; then
                    echo "DEBUG: Six stat sections found for $i"
                  fi
                  MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" \+ "$MONTH4" \+ "$MONTH5" \+ "$MONTH6" )"
                fi
              else
                if [ "$DEBUG" = "TRUE" ]; then
                  echo "DEBUG: Five stat sections found for $i"
                fi
                MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" \+ "$MONTH4" \+ "$MONTH5" )"
              fi
            else
              if [ "$DEBUG" = "TRUE" ]; then
                echo "DEBUG: Four stat sections found for $i"
              fi
              MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" \+ "$MONTH4" )"
            fi
          else
            if [ "$DEBUG" = "TRUE" ]; then
              echo "DEBUG: Three stat sections found for $i"
            fi
            MONTH="$( expr "$MONTH" \+ "$MONTH2" \+ "$MONTH3" )"
          fi
        else
          if [ "$DEBUG" = "TRUE" ]; then
            echo "DEBUG: Two stat sections found for $i"
          fi
          MONTH="$( expr "$MONTH" \+ "$MONTH2" )"
        fi
        NADA="Yepp"
      else
      if [ "$DEBUG" = "TRUE" ]; then
        echo "DEBUG: One stat section found for $i"
      fi        
    fi

    if [ "$EX" != "YES" ]; then
      MONTHUP="$( expr $MONTH \/ 1024 )"
      if [ "$MONTHUP" -gt "$LIMIT" ]; then
        echo "$i - $MONTHUP MB - $GROUP- Safe"
      else
        if [ "$MONTH" -lt "1024" ]; then
           MSG="Idle?"
        else
           MSG="Below limit"
        fi

        ## FLAGDEL is TRUE. Lets put some 6 flags on users. 
        if [ "$FLAGDEL" = "TRUE" ]; then
          FLAGS="$(cat $USERPATH/$i | grep -w FLAGS | awk -F" " '{print $2}')"
          CHECK="$( echo $FLAGS | grep 6 )"
          if [ "$CHECK" != "" ]; then
            DELLED="YES"
            if [ "$DEBUG" = "TRUE" ]; then
              echo "DEBUG: $i - $MONTHUP MB - $GROUP- $MSG . Already delled though."
            fi
          fi
           if [ "$DELLED" != "YES" ]; then
            if [ "$TEST" != "TRUE" ]; then
              cp -f $i $BACKUPFOLDER
              sed -e "s/^FLAGS $FLAGS.*/FLAGS "$FLAGS"6/" $USERPATH/$i > $USERFILETMP
              mv -f $USERFILETMP $USERPATH/$i
            else
              if [ "$DEBUG" = "TRUE" ]; then
                if [ "$YESYES" != "TRUE" ]; then
                  echo "DEBUG: Test mode activated. No users actually delled."
                  YESYES="TRUE"
                fi
              fi
            fi
            FLAGSAFTER="$(cat $USERPATH/$i | grep -w FLAGS | awk -F" " '{print $2}')"
            if [ "$DEBUG" = "TRUE" ]; then
              echo "$i - $MONTHUP MB - $GROUP- $MSG - 6 flag added. Before=$FLAGS After:$FLAGSAFTER"
            else
              echo "$i - $MONTHUP MB - $GROUP- $MSG - Putting flag 6 on him!"
            fi
          fi
        fi
          
        ## REALDEL is TRUE. Lets del some uuuuser.
        if [ "$REALDEL" = "TRUE" ]; then
          echo "$i - $MONTHUP MB - $GROUP- $MSG - Delling permanently!"
          if [ "$TEST" != "TRUE" ]; then
            if [ "$BACKUP" = "TRUE" ]; then
              cp -f $i $BACKUPFOLDER
            fi
            rm -f $i
            USERLINE="$( cat $PASSWD | grep -w $i )"
            if [ "$DEBUG" = "TRUE" ]; then
              echo "DEBUG: passwd line del for $i: $USERLINE"
            fi
            cat $PASSWD | grep -v "$USERLINE" > $USERFILETMP
            mv -f $USERFILETMP $PASSWD
          fi
        fi   

        ## Neither FLAGDEL or REALDEL is TRUE. Lets just looks and see.            
        if [ "$FLAGDEL" != "TRUE" ]; then
          if [ "$REALDEL" != "TRUE" ]; then
            FLAGS="$(cat $USERPATH/$i | grep -w FLAGS | awk -F" " '{print $2}')"
            CHECK="$( echo $FLAGS | grep 6 )"
            if [ "$CHECK" != "" ]; then
              if [ "$DEBUG" = "TRUE" ]; then
                echo "$i - $MONTHUP MB - $GROUP- $MSG , but hes already delled."
              fi
            else
              echo "$i - $MONTHUP MB - $GROUP- $MSG"
            fi
          fi
        fi
      fi
    fi
  fi
fi

  ## Clean up what we found on that user.
  MATCH="NO"
  EX="NO"
  EXXED=""
  DELLED="NO"

done


exit 0
## EOF